# -*- coding: utf-8 -*-
from setuphelpers import *
import time

# Declaring specific app values (TO CHANGE)
bin_name_string = "seafile-%s-en.msi"


def install():
    # Specific app values
    package_version = control.version.split("-")[0]

    #uninstall old version
    for soft in installed_softwares('seafile'):
        if Version(soft['version']) < Version(get_msi_properties(bin_name_string % package_version )['ProductVersion']):
            uninstall()

    # Installing the package
    install_msi_if_needed(bin_name_string % package_version, min_version=package_version)

    uninstallkey.remove(get_msi_properties("seafile-%s-en.msi" % package_version)["ProductCode"])
    remove_desktop_shortcut("Seafile")


def uninstall():


    try:
        for seafile in installed_softwares("seafile"):
            run(uninstall_cmd(seafile["key"]), timeout=20)
    except:
        killalltasks("seafile-applet.exe")
        time.sleep(60)
        if installed_softwares("seafile"):
            error("Error: Seafile is not uninstalled")


def session_setup():
    print("Session setup for %s" % control.asrequirement())
    print("Configuring: auto update check, base options")
    registry_setstring(HKEY_CURRENT_USER, r"Software\Seafile\Seafile Client\WinSparkle", "CheckForUpdates", "0")
    registry_setstring(HKEY_CURRENT_USER, r"Software\Seafile\Seafile Client\Misc", "SparkleAlreadyEnableUpdateByDefault", "true")
    registry_setstring(HKEY_CURRENT_USER, r"Software\Seafile", "ShellExtDisabled", "1")
    registry_setstring(HKEY_CURRENT_USER, r"Software\Seafile\Seafile Client\Behavior", "hideMainWindowWhenStarted", "true")
    registry_setstring(HKEY_CURRENT_USER, r"Software\Seafile\Seafile Client\Language", "current", "en")
